fediverser/apps/core/urls.py
from django.urls import path

from . import views

app_name = "fediverser-core"

urlpatterns = [
    path("", views.HomeView.as_view(), name="portal-home"),
    path(
        "reddit/invites/<str:key>/accept",
        views.RedditorAcceptInviteView.as_view(),
        name="redditor-accept-invite",
    ),
    path(
        "reddit/invites/<str:key>/decline",
        views.RedditorDeclineInviteView.as_view(),
        name="redditor-decline-invite",
    ),
    path("reddit/connect", views.RedditConnectionView.as_view(), name="reddit-connection-setup"),
    path("reddit/login", views.RedditLoginView.as_view(), name="reddit-login"),
    path("lemmy/connect", views.LemmySignupView.as_view(), name="lemmy-connect-setup"),
    path("lemmy/set-password", views.LemmySetPasswordView.as_view(), name="lemmy-set-password"),
    path("activity", views.UserActionListView.as_view(), name="activity-list"),
    path("instances", views.InstanceListView.as_view(), name="instance-list"),
    path("instances/create", views.InstanceCreateView.as_view(), name="instance-create"),
    path("instances/find", views.InstanceFinderView.as_view(), name="instance-find"),
    path("instances/<str:domain>", views.InstanceDetailView.as_view(), name="instance-detail"),
    path(
        "instances/<str:domain>/recommend/category",
        views.InstanceCategoryRecommendationCreateView.as_view(),
        name="instance-categoryrecommendation-create",
    ),
    path(
        "instances/<str:domain>/recommend/country",
        views.InstanceCountryRecommendationCreateView.as_view(),
        name="instance-countryrecommendation-create",
    ),
    path(
        "instances/<str:domain>/annotate/closed",
        views.InstanceClosedAnnotationCreateView.as_view(),
        name="instance-closedannotation-create",
    ),
    path(
        "instances/<str:domain>/annotate/abandoned",
        views.InstanceAbandonedAnnotationCreateView.as_view(),
        name="instance-abandonedannotation-create",
    ),
    path("communities", views.CommunityListView.as_view(), name="community-list"),
    path(
        "communities/create",
        views.CommunityCreateView.as_view(),
        name="community-create",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>",
        views.CommunityDetailView.as_view(),
        name="community-detail",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>/repost/reddit",
        views.CommunityRepostRedditSubmissionView.as_view(),
        name="community-repost-reddit",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>/recommend/category",
        views.CommunityCategoryRecommendationCreateView.as_view(),
        name="community-categoryrecommendation-create",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>/ambassadors/apply",
        views.CommunityAmbassadorApplicationCreateView.as_view(),
        name="community-ambassador-application-create",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>/feeds/create",
        views.CommunityFeedCreateView.as_view(),
        name="community-contentfeed-create",
    ),
    path(
        "reddit/submissions/<str:submission_id>",
        views.RedditSubmissionView.as_view(),
        name="redditsubmission-detail",
    ),
    path("subreddits", views.SubredditListView.as_view(), name="subreddit-list"),
    path("subreddits/create", views.SubredditCreateView.as_view(), name="subreddit-create"),
    path("subreddits/<str:name>", views.SubredditDetailView.as_view(), name="subreddit-detail"),
    path(
        "subreddits/<str:name>/subscribe", views.subscribe_to_subreddit, name="subreddit-subscribe"
    ),
    path(
        "subreddits/<str:name>/unsubscribe",
        views.unsubscribe_from_subreddit,
        name="subreddit-unsubscribe",
    ),
    path(
        "subreddits/<str:name>/recommend/category",
        views.SubredditCategoryRecommendationCreateView.as_view(),
        name="subreddit-categoryrecommendation-create",
    ),
    path(
        "subreddits/<str:name>/recommend/alternative",
        views.SubredditAlternativeRecommendationCreateView.as_view(),
        name="subreddit-alternativerecommendation-create",
    ),
    path(
        "subreddits/<str:name>/request/community",
        views.CommunityRequestCreateView.as_view(),
        name="subreddit-communityrequest-create",
    ),
    path("redditors", views.RedditorListView.as_view(), name="redditor-list"),
    path("redditors/<str:username>", views.RedditorDetailView.as_view(), name="redditor-detail"),
    path(
        "redditors/<str:username>/invite",
        views.RedditorInviteView.as_view(),
        name="redditor-send-invite",
    ),
    path(
        "api/community-requests",
        views.CommunityRequestListView.as_view(),
        name="api-community-request-list",
    ),
    path(
        "api/subreddits",
        views.RedditCommunityListView.as_view(),
        name="api-subreddit-list",
    ),
    path("api/nodeinfo", views.NodeInfoView.as_view(), name="nodeinfo-detail"),
    path(
        "api/fediverser-instances",
        views.FediversedInstanceListView.as_view(),
        name="fediverserinstance-list",
    ),
    path(
        "api/instance/recommendations",
        views.InstanceRecommendationsListView.as_view(),
        name="api-instancerecommendation-list",
    ),
    path(
        "api/changes",
        views.ChangeFeedEntryListView.as_view(),
        name="changefeedentry-list",
    ),
    path(
        "api/changes/<int:pk>",
        views.ChangeFeedEntryDetailView.as_view(),
        name="changefeedentry-detail",
    ),
    path("feed/changes", views.ChangeFeed(), name="changefeed-feed"),
]

fediverser/apps/core/models/mapping.py
import logging

from django.conf import settings
from django.contrib.auth import get_user_model
from django.db import models, transaction
from django_countries.fields import CountryField
from model_utils import Choices
from model_utils.managers import InheritanceManager, QueryManager
from model_utils.models import StatusModel
from taggit.managers import TaggableManager
from wagtail.images.models import Image
from wagtail.snippets.models import register_snippet

from ..signals import instance_abandoned, instance_closed
from .activitypub import Community, Instance
from .common import COMMUNITY_STATUSES, INSTANCE_STATUSES, Category
from .reddit import RedditCommunity

logger = logging.getLogger(__name__)
User = get_user_model()


class AbstractAnnotation(models.Model):
    """
    Annotation entries are meant to provide metadata about the data being tracked
    """

    locked = models.BooleanField(default=False)
    hidden = models.BooleanField(default=False)
    notes = models.TextField()

    class Meta:
        abstract = True


class InstanceAnnotation(AbstractAnnotation):
    instance = models.OneToOneField(Instance, related_name="annotation", on_delete=models.CASCADE)
    status = models.CharField(
        max_length=20, choices=INSTANCE_STATUSES, default=INSTANCE_STATUSES.active
    )

    def __str__(self):
        return self.instance.domain


class CommunityAnnotation(AbstractAnnotation):
    community = models.OneToOneField(
        Community, related_name="annotation", on_delete=models.CASCADE
    )
    status = models.CharField(
        max_length=20, choices=COMMUNITY_STATUSES, default=COMMUNITY_STATUSES.active
    )
    category = models.ForeignKey(
        Category,
        related_name="community_annotations",
        null=True,
        blank=True,
        on_delete=models.SET_NULL,
    )

    def __str__(self):
        return str(self.community)


class SubredditAnnotation(AbstractAnnotation):
    subreddit = models.OneToOneField(
        RedditCommunity, related_name="annotation", on_delete=models.CASCADE
    )
    status = models.CharField(
        max_length=20, choices=COMMUNITY_STATUSES, default=COMMUNITY_STATUSES.active
    )
    category = models.ForeignKey(
        Category,
        related_name="subreddit_annotations",
        null=True,
        blank=True,
        on_delete=models.SET_NULL,
    )

    def __str__(self):
        return str(self.subreddit)


@register_snippet
class Topic(models.Model):
    code = models.SlugField(unique=True)
    name = models.CharField(max_length=64, unique=True)
    description = models.TextField()
    icon = models.ForeignKey(
        Image, related_name="topics_icons", null=True, blank=True, on_delete=models.SET_NULL
    )
    tags = TaggableManager()

    def __str__(self):
        return self.name


class InstanceTopic(models.Model):
    instance = models.ForeignKey(Instance, related_name="topics", on_delete=models.CASCADE)
    topic = models.ForeignKey(Topic, related_name="instances", on_delete=models.CASCADE)

    class Meta:
        unique_together = ("instance", "topic")


class InstanceCountry(models.Model):
    instance = models.ForeignKey(
        Instance, related_name="related_countries", on_delete=models.CASCADE
    )
    country = CountryField()

    class Meta:
        unique_together = ("instance", "country")


class InstanceExtraInformation(models.Model):
    instance = models.OneToOneField(Instance, related_name="extra", on_delete=models.CASCADE)
    invite_only = models.BooleanField(null=True, blank=True)
    application_required = models.BooleanField(null=True, blank=True)
    payment_required = models.BooleanField(default=False)
    abandoned = models.BooleanField(default=False)


class RedditToCommunityRecommendation(models.Model):
    subreddit = models.ForeignKey(
        RedditCommunity, related_name="recommendations", on_delete=models.CASCADE
    )
    community = models.ForeignKey(
        Community, related_name="recommendations", on_delete=models.CASCADE
    )

    def __str__(self):
        return f"Recommendation of {self.community} as alternative to {self.subreddit}"

    class Meta:
        unique_together = ("subreddit", "community")


class ChangeRequest(StatusModel):
    STATUS = Choices("requested", "accepted", "rejected")
    requester = models.ForeignKey(
        settings.AUTH_USER_MODEL, related_name="change_requests", on_delete=models.CASCADE
    )
    objects = InheritanceManager()
    pending = QueryManager(status=STATUS.requested)

    @property
    def description(self):
        return f"Change request #{self.id} {self.__class__.__name__}"

    @property
    def auto_accept(self):
        return self.requester.is_staff

    def apply(self):
        raise NotImplementedError("Child classes need to implement this method")

    def accept(self):
        self.apply()
        self.status = self.STATUS.accepted
        self.save()

    def reject(self):
        self.status = self.STATUS.rejected
        self.save()


class RecommendCommunity(ChangeRequest):
    subreddit = models.ForeignKey(
        RedditCommunity, related_name="recommendation_requests", on_delete=models.CASCADE
    )
    community = models.ForeignKey(Community, on_delete=models.CASCADE)

    @property
    def description(self):
        return f"Recommend {self.community.fqdn} as alternative to {self.subreddit}"

    def apply(self):
        self.subreddit.recommendations.create(community=self.community)


class SetRedditCommunityCategory(ChangeRequest):
    subreddit = models.ForeignKey(
        RedditCommunity, related_name="category_change_requests", on_delete=models.CASCADE
    )
    category = models.ForeignKey(Category, on_delete=models.CASCADE)

    @property
    def description(self):
        return f"Recommend {self.category.name} as category to {self.subreddit}"

    def apply(self):
        SubredditAnnotation.objects.update_or_create(
            subreddit=self.subreddit, defaults={"category": self.category}
        )


class SetCommunityCategory(ChangeRequest):
    community = models.ForeignKey(
        Community, related_name="category_change_requests", on_delete=models.CASCADE
    )
    category = models.ForeignKey(Category, on_delete=models.CASCADE)

    @property
    def description(self):
        return f"Recommend category {self.category.name} to {self.community}"

    def apply(self):
        CommunityAnnotation.objects.update_or_create(
            community=self.community, defaults={"category": self.category}
        )


class SetInstanceCategory(ChangeRequest):
    instance = models.ForeignKey(
        Instance, related_name="category_change_requests", on_delete=models.CASCADE
    )
    category = models.ForeignKey(Category, on_delete=models.CASCADE)

    @property
    def description(self):
        return f"Recommend category {self.category.name} to {self.instance}"

    def apply(self):
        InstanceAnnotation.objects.update_or_create(
            instance=self.instance, defaults={"category": self.category}
        )


class SetInstanceCountry(ChangeRequest):
    instance = models.ForeignKey(
        Instance, related_name="country_selection_requests", on_delete=models.CASCADE
    )
    country = CountryField()

    @property
    def description(self):
        return f"Set {self.instance} as for people from {self.country.name}"

    def apply(self):
        InstanceCountry.objects.get_or_create(instance=self.instance, country=self.country)


class SetInstanceAsClosed(ChangeRequest):
    instance = models.ForeignKey(
        Instance, related_name="instance_closed_annotations", on_delete=models.CASCADE
    )

    @property
    def description(self):
        return f"Set {self.instance} as closed"

    def apply(self):
        with transaction.atomic():
            annotation, _ = InstanceAnnotation.objects.get_or_create(instance=self.instance)
            annotation.status = INSTANCE_STATUSES.closed
            annotation.save()
            instance_closed.send(instance=self.instance, sender=Instance)


class SetInstanceAsAbandoned(ChangeRequest):
    instance = models.ForeignKey(
        Instance, related_name="instance_abandoned_annotations", on_delete=models.CASCADE
    )

    @property
    def description(self):
        return f"Set {self.instance} as abandoned"

    def apply(self):
        with transaction.atomic():
            extra, _ = InstanceExtraInformation.objects.get_or_create(instance=self.instance)
            extra.abandoned = True
            extra.save()
            annotation, _ = InstanceAnnotation.objects.get_or_create(instance=self.instance)
            annotation.status = INSTANCE_STATUSES.abandoned
            annotation.save()
            instance_abandoned.send(instance=self.instance, sender=Instance)


class CommunityRequest(StatusModel):
    STATUS = Choices("requested", "accepted", "rejected")
    requested_by = models.ForeignKey(
        settings.AUTH_USER_MODEL, related_name="community_requests", on_delete=models.CASCADE
    )
    instance = models.ForeignKey(
        Instance, related_name="community_requests", on_delete=models.CASCADE
    )
    subreddit = models.ForeignKey(
        RedditCommunity, related_name="community_requests", on_delete=models.CASCADE
    )
    fulfilled_by = models.ForeignKey(
        Community,
        related_name="creation_requests",
        null=True,
        blank=True,
        on_delete=models.SET_NULL,
    )


__all__ = (
    "InstanceAnnotation",
    "CommunityAnnotation",
    "SubredditAnnotation",
    "Topic",
    "InstanceCountry",
    "InstanceTopic",
    "InstanceExtraInformation",
    "RedditToCommunityRecommendation",
    "ChangeRequest",
    "SetRedditCommunityCategory",
    "RecommendCommunity",
    "SetCommunityCategory",
    "SetInstanceCategory",
    "SetInstanceCountry",
    "SetInstanceAsClosed",
    "SetInstanceAsAbandoned",
    "CommunityRequest",
)

fediverser/apps/core/templates/portal/instance/create.tmpl.html
{% extends "portal/generic/form.tmpl.html" %}

{% block actions %}
<input type="submit" value="Submit" class="button" />
{% endblock %}

fediverser/apps/core/templates/portal/instance/detail.tmpl.html
{% extends "portal/generic/base.tmpl.html" %}
{% load fediverser %}

{% block main_header %}
{% include "portal/instance/header.tmpl.html" with title=page_title subtitle=page_subtitle action_url=None action_text=None icon=None instance=object %}
{% endblock %}

{% block main_content %}
<dl>
  <dt>Instance URL</dt>
  <dd><a href="{{ object.url }}"}} target="_blank">{{ object.url }}</a></dd>
  {% if object.related_countries.exists %}
  <dt>Recommended for people in</dt>
  <dd>
    {% for related_country in object.related_countries.all %}
    {{ related_country.country.name }}

    <img class="flag" src="{{ related_country.country.flag }}" alt="Flag of {{ related_country.country.name }}" />
    <br />
    {% endfor %}
  </dd>
  {% endif %}
</dl>
<hr />

<h3>Local Groups?</h3>
{% if not user|pending_instance_country_proposal:object %}
<p>If this instance is for users of a country or common region, you can indicate it here:</p>
<form action="{% url 'fediverser-core:instance-countryrecommendation-create' domain=object.domain %}" method="POST" novalidate>
  {% csrf_token %}
  <ul class="fields">
    {% for field in country_picker_form.visible_fields %}
    <li>
      {% include "wagtailadmin/shared/field.html" %}
    </li>
    {% endfor %}
    <li>
      <input type="submit" value="Submit Country" class="button" />
    </li>
  </ul>
</form>
{% else %}
<p>You already recommended a country! Please check your <a href="{% url 'fediverser-core:activity-list' %}">activity page</a> for more information.</p>
{% endif %}

{% endblock %}

{% block extra_js %}
{{ block.super }}
{{ status_picker_form.media.js }}
{{ category_picker_form.media.js }}
{% endblock %}

{% block extra_css %}
{{ block.super }}
{{ status_picker_form.media.css }}
{{ category_picker_form.media.css }}
{% endblock %}

fediverser/apps/core/templates/portal/instance/header.tmpl.html
{% extends "portal/partials/header.tmpl.html" %}
{% load wagtailadmin_tags fediverser %}

{% block right_column %}
<div class="actionbutton">
  {% if instance|is_active_instance %}
  <form action="{% url 'fediverser-core:instance-abandonedannotation-create' domain=instance.domain %}" method="POST" novalidate>
    {% csrf_token %}
    <button class="button bicolor button--icon">{% icon name='warning' wrapped=1 %}Report as Abandoned</button>
  </form>
  {% elif instance|is_abandoned_instance %}
  <form action="{% url 'fediverser-core:instance-closedannotation-create' domain=instance.domain %}" method="POST" novalidate>
    {% csrf_token %}
    <button class="button bicolor button--icon">{% icon name='warning' wrapped=1 %}Report as Closed</button>
  </form>
  {% endif %}
</div>
{% endblock %}

fediverser/apps/core/templates/portal/instance/list.tmpl.html
{% extends "portal/generic/listing.tmpl.html" %}
{% load wagtailadmin_tags %}

{% block listing %}
<table class="listing listing--inline-actions">
  <thead>
    <tr>
      <th scope="col">Domain</th>
      <th scope="col">Software</th>
      <th scope="col">Status</th>
    </tr>
  </thead>
  <tbody>
    {% for instance in object_list %}
    <tr>
      <td class="title">
        <div class="title-wrapper">
          <a href="{% url 'fediverser-core:instance-detail' domain=instance.domain %}">
            {{ instance.domain }}
          </a>
          <a href="{{ instance.url }}" target="_blank">🌐</a>
        </div>
      </td>
      <td>{{ instance.get_software_display }}</td>
      <td>{{ instance.annotation.get_status_display|default:"Unknown" }}</td>
    </tr>
    {% endfor %}
  </tbody>
</table>
{% endblock %}

fediverser/apps/core/templates/portal/instance/signup.tmpl.html
{% extends "portal/generic/form.tmpl.html" %}
{% load fediverser %}

{% block before_form %}
{% fediversed_lemmy as fediversed_lemmy_configuration %}
<p>Please fill the form below to complete your registration on {{ fediversed_lemmy_configuration.instance.domain }}.</p>
{% endblock %}